//-----------------------------------------------------------------------------
//
//						XMM Science Analysis System (SAS)
//					   (c) 1997-2010 European Space Agency
//
//-----------------------------------------------------------------------------
//
//	BadPixelMap.cc --- implementation of BadPixel related classes
//
//	DESCRIPTION:
//
//	CHANGE HISTORY:
//		UL, 2001-03-22: 1.0.0: - first version (from BadPixelDataServer.cc in
//								 CAL)
//
//	AUTHOR:
//		U. Lammers, Thu Mar 22 18:52:45 MET 2001
//
//	REFERENCES:
//		[1]: Software Specification Document for the XMM Science Analysis
//			 Subsystem, M. Dahlem et. al., 
//
//	$Header: /data/xmm02/cvsadmin/soc_repos/sas/packages/caloalutils/src/BadPixelMap.cc,v 1.2 2001/03/22 18:20:44 ulammers Exp $
//

#include <functional>	//	binders
#include <algorithm>
#include <cmath>

#include "CalOalUtility.h"
#include "BadPixelMap.h"

using namespace CalOalUtility;

//
//	--------------------------( BadPixelMap )-----------------------------
//
const BadPixel *BadPixelMap::isPixelBad(const PixelLocation &where) const
{
	PROC

	BadPixelMapType::const_iterator i = find(where);

	if (i != end())
		//	yes, this is a bad pixel
		ALTRETURNV(&(*i).second)

	RETURN static_cast<BadPixel *>(0);	//	no pixel is not bad
} // BadPixelMaps::isPixelBad

