//-----------------------------------------------------------------------------
//
//						XMM Science Analysis System (SAS)
//					   (c) 1997 - 2010 European Space Agency
//
//-----------------------------------------------------------------------------
//
//	xmm_c.cc --- implementation of C I/F layer to XMM class
//
//	DESCRIPTION:
//		See STime.h
//
//	CHANGE HISTORY:
//		UL, 2001-05-10: 1.0.0: - first version
//
//	AUTHOR:
//		U. Lammers,	Thu May 10 14:10:42 MET DST 2001
//
//	REFERENCES:
//		[1]: Software Specification Document for the XMM Science Analysis
//			 Subsystem, M. Dahlem et. al.,
//
//	$Header: /data/xmm02/cvsadmin/soc_repos/sas/packages/caloalutils/src/xmm_c.cc,v 1.2 2001/07/16 10:18:35 ulammers Exp $
//

#include "common.h"
#include "Xmm.h"
#include "xmm.h"
#include "Handle.h"

#define CSTC(ptr)   ((const STime *)ptr)

typedef Handle<STime>	STimeHandleF90;

extern "C" {

#define XMMFIXTIME(upp, low)							\
STimeHandle CAT(XMM_, upp)()							\
{														\
	return STimeHandle(&CAT(Xmm::, upp));				\
}														\
														\
STimeHandleF90 CXXFUNC(CAT(xmm_, low), CAT(XMM_, upp))()\
{														\
	return STimeHandleF90(CSTC(XMM_##upp()));			\
}

XMMFIXTIME(missionReferenceTime, missionreferencetime)
XMMFIXTIME(missionStartTime, missionstarttime)
XMMFIXTIME(missionEndTime, missionendtime)

}
